std::chrono Namespace Reference
Utilities » Time

## Classes

struct | duration
struct | duration_values
struct | time_point
struct | treat_as_floating_point

## Typedefs

typedef duration< int64_t, ratio< 3600 > > | hours
typedef duration< int64_t, micro > | microseconds
typedef duration< int64_t, milli > | milliseconds
typedef duration< int64_t, ratio< 60 > > | minutes
typedef duration< int64_t, nano > | nanoseconds
typedef duration< int64_t > | seconds

## Functions

template<typename _ToDur , typename _Rep , typename _Period >
constexpr enable_if< __is_duration< _ToDur >::value, _ToDur >::type | duration_cast (const duration< _Rep, _Period > &__d)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr bool | operator!= (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Dur2 >
constexpr bool | operator!= (const time_point< _Clock, _Dur1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _Rep1 , typename _Period , typename _Rep2 >
constexpr duration< typename __common_rep_type< _Rep1, typename enable_if<!__is_duration< _Rep2 >::value, _Rep2 >::type >::type, _Period > | operator% (const duration< _Rep1, _Period > &__d, const _Rep2 &__s)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr common_type< duration< _Rep1, _Period1 >, duration< _Rep2, _Period2 > >::type | operator% (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Rep1 , typename _Period , typename _Rep2 >
constexpr duration< typename __common_rep_type< _Rep1, _Rep2 >::type, _Period > | operator* (const duration< _Rep1, _Period > &__d, const _Rep2 &__s)
template<typename _Rep1 , typename _Rep2 , typename _Period >
constexpr duration< typename __common_rep_type< _Rep2, _Rep1 >::type, _Period > | operator* (const _Rep1 &__s, const duration< _Rep2, _Period > &__d)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr common_type< duration< _Rep1, _Period1 >, duration< _Rep2, _Period2 > >::type | operator+ (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Rep2 , typename _Period2 >
constexpr time_point< _Clock, typename common_type< _Dur1, duration< _Rep2, _Period2 > >::type > | operator+ (const time_point< _Clock, _Dur1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Rep1 , typename _Period1 , typename _Clock , typename _Dur2 >
constexpr time_point< _Clock, typename common_type< duration< _Rep1, _Period1 >, _Dur2 >::type > | operator+ (const duration< _Rep1, _Period1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr common_type< duration< _Rep1, _Period1 >, duration< _Rep2, _Period2 > >::type | operator- (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Rep2 , typename _Period2 >
constexpr time_point< _Clock, typename common_type< _Dur1, duration< _Rep2, _Period2 > >::type > | operator- (const time_point< _Clock, _Dur1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Dur2 >
constexpr common_type< _Dur1, _Dur2 >::type | operator- (const time_point< _Clock, _Dur1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _Rep1 , typename _Period , typename _Rep2 >
constexpr duration< typename __common_rep_type< _Rep1, typename enable_if<!__is_duration< _Rep2 >::value, _Rep2 >::type >::type, _Period > | operator/ (const duration< _Rep1, _Period > &__d, const _Rep2 &__s)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr common_type< _Rep1, _Rep2 >::type | operator/ (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr bool | operator< (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Dur2 >
constexpr bool | operator< (const time_point< _Clock, _Dur1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr bool | operator<= (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Dur2 >
constexpr bool | operator<= (const time_point< _Clock, _Dur1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr bool | operator== (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Dur2 >
constexpr bool | operator== (const time_point< _Clock, _Dur1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr bool | operator> (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Dur2 >
constexpr bool | operator> (const time_point< _Clock, _Dur1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _Rep1 , typename _Period1 , typename _Rep2 , typename _Period2 >
constexpr bool | operator>= (const duration< _Rep1, _Period1 > &__lhs, const duration< _Rep2, _Period2 > &__rhs)
template<typename _Clock , typename _Dur1 , typename _Dur2 >
constexpr bool | operator>= (const time_point< _Clock, _Dur1 > &__lhs, const time_point< _Clock, _Dur2 > &__rhs)
template<typename _ToDur , typename _Clock , typename _Dur >
constexpr enable_if< __is_duration< _ToDur >::value, time_point< _Clock, _ToDur > >::type | time_point_cast (const time_point< _Clock, _Dur > &__t)

## Detailed Description

ISO C++ 2011 entities sub-namespace for time and date.

## Typedef Documentation

## hours

typedef duration<int64_t, ratio<3600> > std::chrono::hours

hours

Definition at line 542 of file chrono.

## microseconds

typedef duration<int64_t, micro> std::chrono::microseconds

microseconds

Definition at line 530 of file chrono.

## milliseconds

typedef duration<int64_t, milli> std::chrono::milliseconds

milliseconds

Definition at line 533 of file chrono.

## minutes

typedef duration<int64_t, ratio< 60> > std::chrono::minutes

minutes

Definition at line 539 of file chrono.

## nanoseconds

typedef duration<int64_t, nano> std::chrono::nanoseconds

nanoseconds

Definition at line 527 of file chrono.

## seconds

typedef duration<int64_t> std::chrono::seconds

seconds

Definition at line 536 of file chrono.

## Function Documentation

## duration_cast()

template<typename _ToDur , typename _Rep , typename _Period >

constexpr enable_if<__is_duration<_ToDur>::value, _ToDur>::type std::chrono::duration_cast | ( | const duration< _Rep, _Period > & | __d | ) |

duration_cast

Definition at line 194 of file chrono.

## time_point_cast()

template<typename _ToDur , typename _Clock , typename _Dur >

constexpr enable_if<__is_duration<_ToDur>::value, time_point<_Clock, _ToDur> >::type std::chrono::time_point_cast | ( | const time_point< _Clock, _Dur > & | __t | ) |

time_point_cast

Definition at line 604 of file chrono.